unit tableaddfrm;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, Grids,
  StdCtrls, ExtCtrls, CheckLst, DBGrids,
  memds, db, LCLType, Menus, variants;

type

  { TTableAddForm }

  TTableAddForm = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    CheckListBox1: TCheckListBox;
    CheckListBox2: TCheckListBox;
    ComboBox1: TComboBox;
    Panel1: TPanel;
    StringGrid1: TStringGrid;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure CheckListBox1Exit(Sender: TObject);
    procedure CheckListBox2Exit(Sender: TObject);
    procedure ComboBox1EditingDone(Sender: TObject);
    procedure ComboBox1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure MenuItem1Click(Sender: TObject);
    procedure StringGrid1DrawCell(Sender: TObject; aCol, aRow: Integer;
      aRect: TRect; aState: TGridDrawState);
    procedure StringGrid1SelectEditor(Sender: TObject; aCol, aRow: Integer;
      var Editor: TWinControl);
  public
    Add : Boolean;
  end;

var
  TableAddForm: TTableAddForm;

implementation

uses
    main;

{ TTableAddForm }

procedure TTableAddForm.FormCreate(Sender: TObject);
var
  y: Integer;
  x: Integer;
begin

end;

procedure TTableAddForm.FormShow(Sender: TObject);
begin
  ComboBox1.Items.Clear;
  //GetTypeNames(ComboBox1.Items,MainForm.ConnectionMetadata);
end;

procedure TTableAddForm.MenuItem1Click(Sender: TObject);
begin
  //StringGrid1.Click;
end;

procedure TTableAddForm.StringGrid1DrawCell(Sender: TObject; aCol,
  aRow: Integer; aRect: TRect; aState: TGridDrawState);
var
   ImageIndex : Integer;
begin
  if aRow = 0 then
  begin
      with (Sender as TStringGrid) do
      begin
          ImageIndex:=0;
          //Canvas.Brush.Color:=clHighlight;
          Canvas.FillRect(aRect);
          Canvas.TextOut(aRect.Left + 20, aRect.Bottom div 4, Columns.Items[aCol].Title.Caption);
          case aCol of
               0: ImageIndex := 32;
               1: ImageIndex := 31;
               2: ImageIndex := 37;
               3: ImageIndex := 37;
               4: ImageIndex := 37;
               5: ImageIndex := 37;
          end;
          //MainForm.IconList.Draw(Canvas,aRect.Left,aRect.Bottom div 5,ImageIndex);
      end;
  end;
end;

procedure TTableAddForm.ComboBox1EditingDone(Sender: TObject);
begin
  StringGrid1.Cells[StringGrid1.Col,StringGrid1.Row]:=(Sender as TComboBox).Text;
end;

procedure TTableAddForm.ComboBox1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_RETURN then
     //(Sender as TComboBox).DoExit;
end;

procedure TTableAddForm.CheckListBox1Exit(Sender: TObject);
begin
   with StringGrid1 do
  begin
       Cells[Col,Row] := BoolToStr(CheckListBox1.Checked[0],true);
  end;
end;

procedure TTableAddForm.CheckListBox2Exit(Sender: TObject);
var
   t : String;
begin
  with CheckListBox2 do
  with StringGrid1 do
  begin
      t := '';

      if not Checked[0] then
         t := t + 'NOT ';

      t := t + 'NULL ';

      if Checked[1] then
         t := t + 'AUTO INCREMENT';

      Cells[Col,Row]:=t;
  end;
end;

procedure TTableAddForm.Button1Click(Sender: TObject);
begin
  with StringGrid1 do
  begin
      RowCount:=RowCount+1;
  end;
end;

procedure GridDeleteRow(RowNumber: Integer; Grid: TstringGrid);
var
  i: Integer;
begin
  with Grid do
  begin
    for i := RowNumber to RowCount-2 do
      Rows[i].Assign(Rows[i+1]);
    RowCount := RowCount - 1
  end;
end;

procedure TTableAddForm.Button2Click(Sender: TObject);
begin
    with StringGrid1 do
    begin
    if MessageDlg ('Delete!', 'Do you want to delete the column "'+ Cells[1,Row] +'"?',
       mtConfirmation, [mbYes, mbNo],0) = mrYes
    then begin
            GridDeleteRow(StringGrid1.Row,StringGrid1);
        end;
    end;
end;

procedure TTableAddForm.StringGrid1SelectEditor(Sender: TObject; aCol, aRow: Integer;
  var Editor: TWinControl);
begin
  if aRow=0 then Exit;
  with (Sender as TStringGrid) do
  case aCol of
       0: begin
          CheckListBox1.Checked[0] := false;

          CheckListBox1.BoundsRect := CellRect(aCol,aRow);
          if Cells[aCol,aRow] = 'True' then
             CheckListBox1.Checked[0] := true;

          Editor := CheckListBox1;
          end;
       2: begin
          with ComboBox1 do
          begin
               BoundsRect := CellRect(aCol,aRow);
               Text := Cells[Col,Row];
          end;
          Editor:=ComboBox1;
          end;
        5: begin
           with CheckListBox2 do
           begin
                BoundsRect := CellRect(aCol,aRow);
                Checked[0]:=true;
                Checked[1]:=false;

                if Pos('NOT NULL',Cells[aCol,aRow]) <> 0 then
                   Checked[0] := false;

                if Pos('AUTO INCREMENT',Cells[aCol,aRow]) <> 0 then
                   Checked[1] := true;

                Height:=40;
           end;

           Editor := CheckListBox2;
           end;
  end;
end;

initialization
  {$I tableaddfrm.lrs}

end.

